package com.javahonk.adapter;

import java.io.IOException;
import java.util.List;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.io.IOUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import com.javahonk.model.AddressBook;
import com.javahonk.model.SerializeObject;

public class PlainObjectProcessor implements ServerMessageProcessor {

    private static final Logger logger = LogManager.getLogger(PlainObjectProcessor.class.getName());

    @SuppressWarnings("unchecked")
	public void handleRequest(HttpServletRequest request, HttpServletResponse response) throws IOException, ClassNotFoundException {

        byte[] message = IOUtils.toByteArray(request.getInputStream());

        List<AddressBook> object = (List<AddressBook>) SerializeObject.deserialize(message);        

        logger.info("Successfully parsed message {}", message);

        ServletOutputStream outputStream = response.getOutputStream();
        
		outputStream.write(SerializeObject.serialize(object));
    }

}
