package com.javahonk.service;

import javax.annotation.PostConstruct;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.eclipse.jetty.server.Connector;
import org.eclipse.jetty.server.Server;
import org.eclipse.jetty.server.ServerConnector;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;

public class JettyService {

	@Value("${web.port}")
	private int port;
	
	@Autowired
	private MessageHandler handler; 

	@Autowired
	Server server;

	private static final Logger logger = LogManager.getLogger(MessageHandler.class.getName());
	
	public void setPort(int port) {
		this.port = port;
	}
	
	public void setMessageHandler(MessageHandler handler) {
		this.handler = handler;
	}
	
	@PostConstruct
    public void init() throws Exception {

		logger.info("starting jetty server at port {}", port);
		ServerConnector connector = new ServerConnector(server);
        connector.setPort(port);
        server.setConnectors(new Connector[] { connector });
        server.setHandler(handler);
        if (server.isRunning()) {
        	logger.error("Jetty server already running.");
        }
        else
        {
        	server.start();
        }
    }
	
}
