package com.javahonk.test;

import java.io.IOException;
import java.net.MalformedURLException;
import java.util.ArrayList;
import java.util.List;

import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

import org.apache.commons.io.IOUtils;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.ByteArrayEntity;
import org.apache.http.impl.client.HttpClientBuilder;

import com.javahonk.model.AddressBook;
import com.javahonk.model.SerializeObject;

public class HTTPPostSendTestData {

	public static void main(String[] args) throws IOException, ClassNotFoundException {
		postHttpAsString("http://localhost:8080/app/javahonk/testPlainObject", buildDataFromObject());
	}

	@SuppressWarnings("unchecked")
	private static void postHttpAsString(String url, byte[] message) throws ClassNotFoundException {

		try {
			HttpClient httpClient = HttpClientBuilder.create().build();
			HttpPost postRequest = new HttpPost(url);

			ByteArrayEntity entity = new ByteArrayEntity(message);
			entity.setContentType(MediaType.APPLICATION_OCTET_STREAM);
			postRequest.setEntity(entity);

			HttpResponse response = httpClient.execute(postRequest);

			if (response.getStatusLine().getStatusCode() != Response.Status.OK.getStatusCode()) {
				throw new RuntimeException("Failed : HTTP error code : " + response.getStatusLine().getStatusCode());
			}
			
			byte[] value = IOUtils.toByteArray(response.getEntity().getContent());
			
			List<AddressBook> addressBook = (List<AddressBook>) SerializeObject.deserialize(value);
			
			addressBook.stream().forEach(address ->{
	        	System.out.println(address.getName());
	        	System.out.println(address.getApartmentName());
	        	System.out.println(address.getStreeName());
	        	System.out.println(address.getCity());
	        	System.out.println(address.getZipCode());
	        	System.out.println(address.getCountry());
	        });

		} catch (MalformedURLException e) {

			e.printStackTrace();

		} catch (IOException e) {

			e.printStackTrace();

		}
	}
	
	private static byte [] buildDataFromObject() throws IOException{
		
		List<AddressBook> addressBooks = new ArrayList<AddressBook>();
		
		AddressBook addressBook = new AddressBook("JavaHonk", "55C", "John Steet", "Monroe",  new Integer(8863), "USA");
		addressBooks.add(addressBook);
		addressBooks.add(addressBook);
		
		return SerializeObject.serialize(addressBooks);
		
	}

}
